<template>
    <div style="box-sizing: border-box">
        <template v-if="authError === '' && unknownError === ''">
            <q-banner v-for="(e,i) in errors" :key="i" dense class="bg-red text-white">
                <template v-slot:avatar>
                    <q-icon name="icofont-warning"/>
                </template>
                {{ e }}
            </q-banner>
            <slot :submitError="SubmitError"></slot>
        </template>
        <template v-else-if="authError !== ''">
            <ErrorComponent :max-height="1" text="Error - No Tissue (No permission)"
                            :animation="$animations.errors.noTissue"
                            :error-detail="authError"/>
        </template>
        <template v-else>
            <ErrorComponent :max-height="1" text="Error - Dog eats newspaper"
                            :animation="$animations.errors.dogEatsNewspaper"
                            :error-detail="unknownError"
            />
        </template>
        <slot name="end"></slot>
    </div>
</template>
<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import ErrorComponent from "components/Core/ErrorComponent.vue";
import {ApiError} from "src/classLibrary/Core/Api";
import {StandardDotNetError} from "src/classLibrary/Core/Standard";

@Component({
    components: {ErrorComponent}
})
export default class DocumentWrapper extends Vue {
    authError: string = '';
    unknownError: string = '';
    errors: string[] = [];


    SubmitError(e: ApiError) {
        const parent = this;

        ApiError.match(e, {
            Null: (e) => {
                const err = (e.error?.IsEmpty() ?? true) ? 'Not found' : e.error!;
                parent.errors = [err];
            },
            Object: (e) => {
                const dne = e as any as StandardDotNetError;
                new Map<string, string[]>(Object.entries(dne.errors))
                    .Each((_, v) => parent.errors.push(...v));
            },
            Auth: (e) => {
                const err = (e.error?.IsEmpty() ?? true) ? 'No permission' : e.error;
                console.error(err);
                parent.authError = err
            },
            String: (e) => {
                parent.errors = [e.error];
            },
            Unknown: (e) => {
                console.error(e);
                if (typeof e.error === "string") {
                    parent.unknownError = (e.error?.IsEmpty() ?? true) ? "Unknown Error" : ""
                } else {
                    const myError = e.error;
                    if (myError && myError.stack && myError.message) {
                        parent.unknownError = {stack: myError.stack, error: myError.message} as any;
                    } else {
                        parent.unknownError = JSON.stringify(e.error ?? {})
                    }
                }
            }
        })
        return true;
    }
}
</script>
